#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

import string, math, time, datetime

files = {'1997': ('M3', 'M4a', 'M4b', 'M5b', 'M6a', 'M6b', 'M7b', 'M8', 'L0a',
  'L0b', 'L1a', 'L2a', 'L4', 'L6', 'L7', 'L8'),
  '1998': ('M2b', 'M2c', 'M3', 'M4a', 'M4b', 'M5', 'M6a', 'M6b',
  'M7a', 'M7b', 'M7d', 'M8a', 'M8c', 'L1a', 'L1b', 'L2a', 'L2b',
  'L3a', 'L4a', 'L4b', 'L5a', 'L5b', 'L6', 'L7', 'L8', 'L9b',
  'E1', 'E3', 'E4', 'E6', 'E7'),
  '1999': ('M2a', 'M2b', 'M3', 'M4', 'M5', 'M7', 'M8', 'M9', 'M10', 'L1',
  'L2', 'L3', 'L4', 'L5', 'L7', 'L8', 'LX', 'L9', 'E0', 'E1', 'E2', 'E3',
  'E4', 'E5', 'E7'),
  '2000': ('M3', 'M4', 'M5', 'M6', 'M8', 'L0', 'L1', 'L6'),
  '2001': ('M1', 'M2a', 'M2b', 'M3', 'M4', 'M5', 'M6a', 'M6b', 'M7a',
  'M7b', 'M8', 'MX', 'L1', 'L2', 'L3', 'L4', 'L5', 'L6', 'L7', 'L8',
  'E1','E2', 'E3', 'E4'),
  '2002': ('M2a', 'M2b', 'M3', 'M4', 'M5', 'M6', 'M7', 'M8',
  'L1', 'L2', 'L3', 'L4', 'L5', 'LX', 'E1'),
  '2003': ('M2a', 'M2b', 'M2c', 'M2d', 'M3a', 'M3b', 'M3c', 'M4a',
  'M4b', 'M5a', 'M5b', 'M6a', 'M6b', 'M7a', 'M7b', 'M8', 'MX', 
  'L1', 'L2a', 'L2b', 'L3a', 'L3b', 'L4', 'L5a', 'L5b', 'L6a', 'L6b',
  'L7', 'L8', 'LX', 'E1a', 'E1b', 'E2a', 'E2b', 'E3', 'E4', 'E5',
  'E7', 'E8', 'EX'),
  '2004': ('M1a', 'M1b', 'M2a', 'M2b', 'M3a', 'M3b', 'M4a', 'M4b', 'M5',
  'M6a', 'M6b', 'M7', 'M8a', 'M8b', 'L1', 'L2', 'L3a', 'L3b', 'L4', 'L5',
  'L6', 'L7', 'L8', 'LX', 'E1', 'E2'),
  '2005': ('M1a', 'M1b', 'M2', 'M3a', 'M3b', 'M4', 'M5', 'M6',
  'M7a', 'M7b', 'M8', 'MX', 'L1', 'L3', 'L4', 'L6', 'L8', 'LX'),
  '2006': ('M2a', 'M2b', 'M3', 'M4', 'M5', 'L1'),
  '2007': ('M1', 'M2', 'M3', 'M4', 'M5', 'M6', 'L2', 'L4', 'L8'),
  '2008': ('M1a', 'M1b', 'M2', 'M3', 'M4', 'M5', 'M6', 'M7', 'L1', 'L2', 'L3',
  'L4', 'L6', 'L7', 'LX'),
  '2009': ('M1', 'M2', 'M3','M5','M6', 'M7','L1','L2','L3','L4','L5'),
  '2010': ('M1a', 'M1b', 'M2a', 'M2b', 'M3', 'M4', 'M5', 'M6', 'M7', 'MX',
  'L1'),
  '2011': ('M1a', 'M1b', 'M2', 'M4', 'L2', 'L3', 'L4', 'LX')}
years = ['1997', '1998', '1999', '2000', '2001', '2002', '2003', '2004',
  '2005', '2006','2007', '2008', '2009', '2010', '2011']
current_year = '2011'




class DipVariant:
    name_table = {}
    
    def __init__(self, name, first_year, totalcentres, start_sc,
      unbalanced = 0, homepage = 0, rank_until = -1):
        DipVariant.name_table[string.upper(name)] = self
        self.name = name
        # dict of starting SCs by letter
        # so the list of letters is start_sc.keys()
        self.start_sc = start_sc
        self.first_year = first_year
        self.totalcentres = totalcentres
        self.unbalanced = unbalanced
        self.rank_until = rank_until
        # URL of external homepage of variant, if 0 the groups homepage is used
        self.homepage = homepage
        # dicts labelled by year
        self.games = {}
        self.avgs = {}
        self.alldayers = []
        if start_sc != {}:
            self.is_drop = 0
        else:
            self.is_drop = 1

    def add_game(self, game):
      if not (self.games.has_key(game.fileyear)):
        self.games[game.fileyear] = []
      self.games[game.fileyear].append(game)

    def find_power(self, str):
        str = string.upper(str)
        if self.start_sc.has_key(str):
            return str
        if self.is_drop:
            self.start_sc[str] = 1
            return str
        str = str[:1]
        if self.start_sc.has_key(str):
            return str
        panic()

    def compute_avg(self, year):
      if(year == 'hist'):
        pregames = concat(self.games)
      else:
        if not self.games.has_key(year):
          return
        pregames = self.games[year]
      games = []
      for g in pregames:
        if g.var_ranking:
          games.append(g)
      if(len(games) == 0):
        games = pregames
      if(len(games) == 0):
        return
      total = {}
      self.avgs[year] = {}
      for pn in self.start_sc.keys():
        total[pn] = 0
        for g in games:
          total[pn] = total[pn] + g.pow_by_letter[pn].score
        self.avgs[year][pn] = total[pn] / len(games)

    def print_detail_summary_horizontal(self, year, f):
        if self.is_drop:
            panic()
        if(year == 'hist'):
          games = concat(self.games)
        else:
          if not self.games.has_key(year):
            return
          games = self.games[year]
        if len(games) == 0:
            return

        f.write('<TR><TH COLSPAN=' + str(2 + len(games)) + '>' + self.name)
        f.write(self.home_page_ref_with_space())
        f.write('</TH></TR>\n')
        f.write('<TR><TH> Pwr. </TH>')
        for g in games:
            g.score()
            # use abbreviated year labels when linking from hist
            f.write('<TH>' + g.link_game_from(year, 1) + g.vr_ast() + '</TH>')
        f.write('<TH> Avg. </TH></TR>\n')

        power_scores = []
        for pn in self.start_sc.keys():
            power_scores.append((self.avgs[year][pn], pn))
        power_scores.sort()
        power_scores.reverse()
        if len(games) >= 20:
          roundfunc = zerodps
        else:
          roundfunc = onedps
        for avg_score, pn in power_scores:
            f.write('<TR ALIGN=CENTER>')
            f.write('<TH>' + pn + '</TH>')
            for g in games:
                f.write(html_table_cell(roundfunc(g.pow_by_letter[pn].score)))
            #   f.write(html_table_cell(twodps(g.pow_by_letter[pn].score)))

            f.write(html_table_cell('<EM>' + twodps(avg_score) + '</EM>'))
            f.write('</TR>\n')

    def print_yearly_summary(self, f):
        if self.is_drop:
            panic()
        
        v_years = self.games.keys()
        if len(v_years) == 0:
            return
        v_years.sort()
        f.write('<TR><TH COLSPAN=' + str(2 + len(v_years)) + '>' + self.name)
        f.write(self.home_page_ref_with_space())
        f.write('</TH></TR>\n')
        f.write('<TR><TH> Pwr. </TH>')
        for y in v_years:
            f.write('<TH>' + html_link(short_season(y), '../' + y +
                '/variant' + str(self.group.id) + '.html') + '</TH>')
        f.write('<TH> Avg. </TH></TR>\n')
        if len(v_years) >= 20:
          roundfunc = zerodps
        else:
          roundfunc = onedps

        power_scores = []
        for pn in self.start_sc.keys():
            power_scores.append((self.avgs['hist'][pn], pn))
        power_scores.sort()
        power_scores.reverse()
        for avg_score, pn in power_scores:
            f.write('<TR ALIGN=CENTER>')
            f.write('<TH>' + pn + '</TH>')
            for y in v_years:
              f.write(html_table_cell(roundfunc(self.avgs[y][pn])))

            f.write(html_table_cell('<EM>' + twodps(avg_score) + '</EM>'))
            f.write('</TR>\n')
        f.write('<TR ALIGN=CENTER>')
        f.write('<TH>Games</TH>')
        for y in v_years:
          f.write(html_table_cell(str(len(self.games[y]))))
        f.write(html_table_cell(str(len(concat(self.games)))))
        f.write('</TR>\n')
    
    def html_ref(self):
      if self.is_drop:
        return self.name
      return self.group.html_ref()

    def html_ref_full(self):
      if self.is_drop:
        return self.name
      return html_link(self.name, 'variant' + str(self.group.id) + '.html')

    def home_page_ref_with_space(self):
      if self.homepage:
        return ' ' + html_link('(homepage)', self.homepage)
      if self.group.homepage:
        return ' ' + html_link('(homepage)', self.group.homepage)
      return ''


class DipVariantGroup:
    name_table = {}
    id = 0
    
    def __init__(self, name, subvariants, homepage = 0):
        DipVariantGroup.name_table[string.upper(name)] = self
        self.id = DipVariantGroup.id
        DipVariantGroup.id = DipVariantGroup.id + 1
        self.name = name
        self.homepage = homepage
        self.instances = subvariants
        for i in subvariants:
          i.group = self

    def has_games(self, year):
      if(year == 'hist'):
        for i in self.instances:
          if not i.games == {}:
            return 1
      else:
        for i in self.instances:
          if i.games.has_key(year):
            return 1
      return 0


    def print_summary(self, year, f):
        unplayed = 1
        for i in self.instances:
          if i.games.has_key(year):
            unplayed = 0
        if unplayed:
          return
        f.write(html_header(self.name + ' (' + year + ')'))
        for i in self.instances:
          f.write('<P ALIGN=CENTER>\n')
          f.write('<TABLE BORDER=1 WIDTH="40%">\n')
          if not i.games.has_key(year):
            continue
          i.compute_avg(year)
          i.print_detail_summary_horizontal(year, f)
          f.write(html_table_close())
        f.write('<p>' + table_link(year))
        f.write('<br>' + html_link('Historical entry',
            '../hist/variant' + str(self.id) + '.html')) 
        
        
    def print_hist_summary(self, f): 
        f.write(html_header(self.name))
        for i in self.instances:
          f.write('<P ALIGN=CENTER>\n')
          f.write('<TABLE BORDER=1 WIDTH="40%">\n')
          if i.games == {}:
            continue
          i.compute_avg('hist')
          # print game-by-game if the variant has been played in a single year,
          # or less than ~2 times per year,
          # print year-by-year otherwise, and also when variant has been
          # played at least twice each year or more than 20 times in total
          detail = 0
          for t in i.games.values():
            if len(t) <= 1:
              detail = 1
          if(len(concat(i.games)) >= (4 + 1.5*len(i.games.keys()))):
            detail = 0
          if(len(concat(i.games)) > 20):
            detail = 0
          if(len(i.games.keys()) == 1):
            detail = 1
          if detail:
            i.print_detail_summary_horizontal('hist', f)
          else:
            i.print_yearly_summary(f)
          f.write(html_table_close())
        f.write('<p>' + html_link('Front', 'front.html'))
        f.write(html_footer())

    def html_ref(self):
        return html_link(self.name, 'variant' + str(self.id) + '.html')

    def html_ref_hist(self):
        return html_link(self.name, '../hist/variant' + str(self.id) + '.html')


def NewVariant(name, first_year, totalcentres, start_sc, unbalanced = 0,
  homepage = 0, rank_until = -1):
    DipVariantGroup(name, [DipVariant(name, first_year, totalcentres,
        start_sc, unbalanced, 0, rank_until)], homepage)
                          #   ^ no separate homepage for the instance

def find_variant(str):
    if string.upper(str[:4]) == 'DROP':
      str = str[5:]
      par = sub_find_variant(str)
      return DipVariant('Drop ' + str, par.first_year, par.totalcentres, {}, 0)
    else:
      return sub_find_variant(str)

def sub_find_variant(str):
    str = string.upper(str) 
    if DipVariant.name_table.has_key(str):
      return DipVariant.name_table[str]
# if variant couldn't be found try identifying group, and use default instance
    if DipVariantGroup.name_table.has_key(str):
      return DipVariantGroup.name_table[str].instances[0]


#balanced variants
NewVariant('Standard', 1901, 34,
           {'A': 3, 'E': 3, 'F': 3, 'G': 3, 'I': 3, 'R': 4, 'T': 3}, 0,
           'http://www.diplomacy-archive.com/resources/strategy.htm')
NewVariant('Bretwalda', 621, 50,
           {'D': 4, 'E': 3, 'G': 3, 'K': 3, 'L': 3, 'M': 4, 'N': 3,
       'P': 3, 'W': 3}, 0,
           'http://www.variantbank.org/results/rules/b/bretwalda2.htm')
NewVariant('Modern', 1995, 64,
           {'B': 4, 'E': 3, 'F': 4, 'G': 4, 'I': 4, 'P': 3, 'R': 5,
            'S': 3, 'T': 4, 'U': 4}, 0,
           'http://www.diplom.org/Zine/W1995A/Mous/Modern.html')
NewVariant('Cantabrigia', 2001, 32,
           {'E': 3, 'T': 3, 'R': 3, 'S': 4, 'K': 3, 'P': 3}, 0,
           'http://www.pilgrim.demon.co.uk/alex/cantab.htm')
NewVariant('Aberration', 1901, 52,
       {'B': 3, 'C': 3, 'E': 3, 'H': 3, 'I': 3, 'P': 3, 'S': 3, 'U': 3, 
       'Z':3}, 0, 
       'http://devel.diplom.org/Email/judge/info.aberration.html')
NewVariant('Youngstown', 1901, 72,
       {'A': 4, 'C': 3, 'E': 4, 'F': 4, 'G': 4, 'I': 4, 'J': 3,
       'N': 3, 'R': 6, 'T': 4}, 0, 
       'http://devel.diplom.org/Email/judge/info.youngstown.html')
NewVariant('Heptarchy', 651, 37,
       {'A': 3, 'C': 3, 'I': 3, 'M': 4, 'N': 3, 'S': 3, 'W': 3}, 0,
       'http://www.diplom.org/Zine/F1996M/Bache/heptarchy.html')

#unbalanced but used to be ranked
NewVariant('Colonial', 1870, 58,
       {'B': 6, 'C': 5, 'F': 3, 'H': 3, 'J': 4, 'R': 5, 'T': 3}, 1,
       'http://devel.diplom.org/Email/judge/info.colonial.html')
DipVariantGroup('Octarine',
[DipVariant('Octarine V6', 1, 42,
  {'A': 3, 'C': 3, 'G': 3, 'H': 3, 'K': 3, 'M': 4, 'O': 3, 'X': 3}, 1),
DipVariant('Octarine V4', 1, 40,
  {'A': 3, 'C': 3, 'G': 3, 'H': 3, 'M': 4, 'N': 3, 'O': 3, 'X': 3}, 1)],
           'http://www.lspace.org/games/afpdip/octarine/index.html')
NewVariant('Classical', 1, 35,
           {'C': 3, 'E': 3, 'M': 3, 'R': 3, 'S': 3}, 1)

#unbalanced/experimental
NewVariant('Devolution', 2001, 51,
           {'A': 3, 'C': 3, 'I': 3, 'L': 3, 'M': 5, 'S': 4, 'W': 4, 'Y': 4}, 1)
NewVariant('Ancient Mediterranean', 1, 35,
           {'R': 3, 'C': 3, 'G': 3, 'P': 3, 'E': 3}, 1,
           'http://variantbank.org/results/rules/a/ancient_mediterranean.htm')
NewVariant('Double Modern', 1, 64,
       {'BU': 8, 'EG': 7, 'FT': 8, 'IR': 9, 'PS': 6}, 1)
NewVariant('Sail Ho!', 1, 16,
       {'E': 2, 'N': 2, 'S': 2, 'W': 2}, 1,
       'http://www.jump.to/SailHo')
NewVariant('Hundred', 1425, 17,
       {'B': 4, 'E': 5, 'F': 4}, 1)
DipVariantGroup('Lunacy',
  [DipVariant('Lunacy V1', 3001, 28,
    {'C': 3, 'G': 3, 'H': 3, 'N': 3, 'P': 3, 'T': 3}, 1)])
DipVariantGroup('Machiavelli',
  [DipVariant('Machiavelli SFD', 1499, 42,
    {'A': 6, 'F': 7, 'L': 3, 'P': 4, 'T': 3, 'V': 4}, 1)])
# L = fLorence



def isapint(str):
    import re
    return re.search(r'[^0-9]', str) == None

# rounding functions
def twodps(i):
    import re
    s = str(round(i, 2))
    while re.search(r'\d+.\d\d', s) == None:
        s = s + '0'
    return s

def onedps(i):
    import re
    s = str(round(i, 1))
    while re.search(r'\d+.\d', s) == None:
        s = s + '0'
    return s

def zerodps(i):
    return str(round(i, 0))[:-2]

def sqr(x):
    return x*x

def cook_line(s):
    # Remove comments.
    try:
        s = s[:string.index(s, '#')]
    except ValueError:
        pass

    # Split into words.
    s = string.split(s)

    return s

def cmpbyavgs(year):
    def cmpyear(a, b):
      return -cmp(a.avgs[year], b.avgs[year])
    return cmpyear

def cmpbyscore(a, b):
    return -cmp(a.score, b.score)

def cmpbyprescore(a, b):
    return -cmp(a.prescore, b.prescore)

def cmpbyname(a, b):
    return cmp(a.name, b.name)

def cmpbysc(a, b):
    return -cmp(a.end_sc, b.end_sc)

def season(year):
    return str(int(year)-1) + '/' + year

def abbr(year):
    return year[2:]

def short_season(year):
    return abbr(str(int(year)-1)) + '/' + abbr(year)

# concatenate the lists in a dict labelled by year
def concat(listbyyear):
    global years
    l = []
    for y in years:
      if y in listbyyear.keys():
        l = l + listbyyear[y]
    return l


# HTML output related functions.

def html_header(title):
    return ('<!DOCTYPE HTML PUBLIC ' +
            '"-//W3C//DTD HTML 4.01 Transitional//EN" ' +
            '"http://www.w3.org/TR/html4/loose.dtd">\n' +
            '<HTML>\n' +
            '<HEAD>\n' +
            '<META http-equiv="Content-Type" ' +
            'content="text/html; charset=ISO-8859-1">\n' + 
            '<TITLE> ' + title + ' </TITLE>\n' +
            '</HEAD>\n' +
            '<BODY BACKGROUND="white_pa.gif">\n')

def html_footer():
    global today_date
    return ('<p>Updated ' + today_date +
            '<br><a href="../../index.html">CU DipSoc home page.</a>' +
            '<br><a href="http://validator.w3.org/check/referer">' +
            '<img border=0 src="http://www.w3.org/Icons/valid-html401"' +
            ' alt="Valid HTML 4.01!" height=31 width=88></a>'
            + '</p>\n</BODY>\n</HTML>\n')

def html_link(caption, url):
    return '<A HREF="' + url + '">' + caption + '</A>'

def html_table_open():
    pass

def html_table_close():
    return '</TABLE>\n'

def html_table_cell(contents):
    return '<TD>' + str(contents) + '</TD>'

def html_table_cell_open():
    return '<TD>'

def html_table_cell_close():
    return '</TD>'

def html_table_header(contents):
    return '<TH>' + contents + '</TH>'

def table_link(year):
    return  html_link(season(year) + ' League table',
        '../' + year + '/table.html')

# each individual game has a collection of DipPowers associated to it
class DipPower:
    def __init__(self, game, powername, player, start_sc, end_sc, last_year):
        self.game = game
        self.name = powername
        self.player = player
        self.start_sc = start_sc
        self.end_sc = end_sc
        self.last_year = last_year

    def print_entry(self, f):
        f.write ('<TR ALIGN="CENTER"><TD>' + self.name +
                 '</TD><TD ALIGN="LEFT">' + self.player.html_ref_local() +
                 '</TD><TD>' + str(self.end_sc) + '</TD>')
        if self.game.prescored:
            f.write ('<TD>' + zerodps(self.prescore) + '</TD>')
        if self.game.scored:
            f.write ('<TD>' + twodps(self.score) + '</TD>')
        f.write ('<TD>' + str(self.last_year) + '</TD></TR>\n')


class DipGame:
    def __init__(self, filename, fileyear):
        print '%%% Loading game: ' + fileyear + '/' + filename, '%%%'        
        self.scored = 0
        self.prescored = 0
        self.nocount = 0
        self.allday = 0
        self.force_ranking = 0
        self.pow_by_letter = {}
        self.pow_by_player = {}
        self.name = filename
        self.fileyear = fileyear
        # 8211 is the code for ndash
        if(filename[0] == 'M'):
          self.long_name = str(int(fileyear)-1) + '&#8211;' + filename
        else:
          self.long_name = fileyear + '&#8211;' + filename
          
        f = open('data/'+ fileyear + '/' + filename, 'r')
        rawlines = f.readlines()
        f.close()

        # Cook the input.
        lines = []
        for s in rawlines:
            s = cook_line(s)
            
            # Don't bother with blank lines.
            if s != []:
                lines.append(s)

        # The first line contains the variant and the last year played
        # It may also contain a label indicating that it does not count
        # towards players' league table rank, or that it does despite the
        # variant being unbalanced
        if (lines[0][-1] == '*'):
            self.nocount = 1
            del lines[0][-1]
        if (lines[0][-1] == '^'):
            self.force_ranking = 1
            del lines[0][-1]

        if not (isapint(lines[0][-1]) or (lines[0][-1][0] == '+' and
                isapint(lines[0][-1][1:]))):
            print lines[0][-1][0]
            print lines[0][-1][1:]
            print '*** The first non-comment line should contain the variant and the first year played. ***'
            panic()

        # Extract the variant name.
        self.variant = find_variant(string.join(lines[0][0:-1]))
        self.variant.add_game(self)
        if('X' in filename):
          self.allday = 1
          self.variant.alldayers.append(self)

        # Extract the last year played
        # A plus sign maybe used to indicate instead the number of years played
        if lines[0][-1][0] == '+':
            self.last_year = int(lines[0][-1][1:]) + self.variant.first_year - 1
        else:
            self.last_year = int(lines[0][-1])
    
        if(self.last_year < self.variant.first_year):
            print '*** Game ends before it begins ***'
            panic()
        if(self.last_year > self.variant.first_year + 40):
            print '*** Game is more than 40 years long ***'
    
        # Get rid of the first line altogether.
        del lines[0]
        
        occupied_scs = 0
        supress_checksum = 0
        for s in lines:
            if string.upper(s[0]) == 'NEUTRAL':
              occupied_scs = occupied_scs + int(s[1])
              continue
            if string.upper(s[0]) == 'SUPRESS':
              supress_checksum = 1
              continue
            powername = self.variant.find_power(s[0])
            del s[0]
            if self.pow_by_letter.has_key(powername):
                print '*** Duplicate power:', powername, '***'
                panic()
            start_sc = self.variant.start_sc[powername]
            i = 0
            while i < len(s) and not isapint(s[i]):
                i = i + 1
            if i == len(s):
                panic()
            playername = string.join(s[0 : i])
            if playername == '':
                print '*** Power', powername, 'has no name! ***'
                panic()
            end_sc = int(s[i])
            occupied_scs = occupied_scs + end_sc
            if end_sc == 0:
                if s[i+1][0] == '+':
                    plast_year = self.variant.first_year + int(s[i + 1]) - 1
                else:    
                    plast_year = int(s[i + 1])
            else:
                plast_year = self.last_year
            if plast_year < self.variant.first_year:
              print '*** Player eliminated before game begins! ***'
            if plast_year > self.last_year:
              print '*** Player eliminated after game ends! ***'
            player = find_player(playername)
            power = DipPower(self, powername, player,
                             start_sc, end_sc, plast_year)
            self.pow_by_letter[powername] = power
            self.pow_by_player[player] = power
            player.add_game(self)
            
        # Sanity checks.
        d = len (self.pow_by_letter) - len(self.variant.start_sc)
        if d > 0:
            print '*** Too many powers in file! ***'
            panic()
        elif d < 0:
            print '*** Too few powers in file! ***'
            print result
            panic()
        # Checksum
        if not supress_checksum:
          if occupied_scs > self.variant.totalcentres:
            print '*** Total number of occupied centres at game end exceeds total number of available centres! ***'
            # panic()
          if occupied_scs < self.variant.totalcentres:
            print '%%% Note: not all centres were occupied at game end. %%%'
        # Q&A
        global total_years
        total_years = total_years + self.last_year - self.variant.first_year +1


    def power_by_playername(self, playername):
        for p in self.pow_by_letter.values():
            if playername == p.player:
                return p
        panic()


    def prescore(self):
        if self.prescored:
            return self
        num_players = len(self.pow_by_letter)

        total_start_sc = 0
        for p in self.pow_by_letter.values():
          total_start_sc = total_start_sc + p.start_sc
        avg_start_sc = 1.0 * total_start_sc / num_players
        avg_avl_sc = 1.0 * self.variant.totalcentres / num_players
        avg_s = avg_start_sc / avg_avl_sc
        m = 1.0
        n = 1.5
        A = 3.0
        B = 1.0
        beta = 0.5

        for p in self.pow_by_letter.values():
          weight = pow(0.75, p.last_year - self.variant.first_year)
          e = 1.0 * p.end_sc / avg_avl_sc
          s = 1.0 * p.start_sc / avg_avl_sc
          mul1 = sqr(e - beta*(s - avg_s) + m) - sqr(m)
          mul2 = sqr(e + n)
          p.prescore = 100*(weight*A*mul1 + 
            (1.0-weight)*(B*mul2 + A*(sqr(1.0+m)-sqr(m)) - B*sqr(1.0+n)))
          # Q&A
          if (self.variant.name == 'Standard' and p.end_sc == 0
            and p.last_year <= self.variant.first_year + 1):
            if (p.name in two_year_elims):
              two_year_elims[p.name].append(self)
            else:
              two_year_elims[p.name] = [self]

        self.prescored = 1
        return self

    def score(self):
        global worst_score, worst_score_key, worst_score_game
        if self.scored:
            return self
        self.prescore()
        total = 0
        for p in self.pow_by_letter.values():
            total = total + p.prescore
        factor = len(self.pow_by_letter) * 50.0 / total
        for p in self.pow_by_letter.values():
          p.score = factor * p.prescore
        self.scored = 1
        return self

    def ranking(self):
      if self.force_ranking:
        return 1
      if (self.nocount or self.allday):
        return 0
      if self.fileyear < self.variant.rank_until:
        return 1
      if self.variant.unbalanced:
        return 0
      if self.variant.rank_until < 0:
        return 1
      else:
        return 0

    # when computing averages for variants it does not make sense to exclude
    # games based on which variant was played!
    def var_ranking(self):
      return not self.allday

    def print_summary(self, f):
        fields = 4
        if self.prescored:
            fields = fields + 1
        if self.scored:
            fields = fields + 1

        f.write (html_header(self.name + ' (' + self.fileyear +')'))
        f.write ('<P ALIGN=CENTER>\n')
        f.write ('<TABLE BORDER="1" WIDTH="40%">\n')
        f.write ('<TR ALIGN=CENTER><TH COLSPAN=' + str(fields) + '>' +
          self.long_name + '\n')
        f.write ('<TR><TH COLSPAN=' + str(fields) + '>')
        f.write (self.variant.html_ref_full())
        f.write (', last year played: ' + str(self.last_year) + '\n')

        if self.scored:
            cf = cmpbyscore
        elif self.prescored:
            cf = cmpbyprescore
        else:
            cf = cmpbysc

        l = self.pow_by_letter.values()[:]
        l.sort(cf)
        for p in l:
            p.print_entry(f)
        f.write (html_table_close())
        f.write ('<p>' + html_link(season(self.fileyear) + ' League table',
            'table.html'))
        f.write (html_footer())


    def link_game_local(self):
        return html_link(self.name, self.name + '.html')

    def link_game_global(self, abbr = 0):
        name = self.long_name
        if abbr:
          name = name[2:]
        return html_link(name, '../' + self.fileyear + '/' + 
            self.name + '.html')
        
    def link_game_from(self, from_year, abbr = 0):
        if(self.fileyear == from_year):
          return self.link_game_local()
        else:
          return self.link_game_global(abbr)
    
    def link_game_short(self):
        return html_link(self.name, '../' + self.fileyear + '/' + 
            self.name + '.html')
        
    def r_ast(self):
      if self.ranking():
        return ''
      else:
        return '*'

    def vr_ast(self):
      if self.var_ranking():
        return ''
      else:
        return '*'


# used when a player isn't identified in the record of the game,
# so that a dud page is not created
class DipPlayerFake:
    def __init__(self, name):
        self.name = name

    def html_ref_local(self):
        return self.name

    def add_game(self, game):
      pass


class DipPlayer:
    master_list = {}
    id = 0

    def __init__(self, name):
        print '%%% New player:', name, '%%%'
        if DipPlayer.master_list.has_key(name):
            panic()
        DipPlayer.master_list[name] = self
        self.name = name
        first_name = string.split(name)[0]
        if names.has_key(first_name):
          self.gender = names[first_name]
        else:    
          names[first_name] = 'u'
          self.gender = 'u'
        # Ticts labelled by year
        # The values are defined by calls from make_league_table
        # This must be done before 'historical' routines are called
        self.games = {}
        self.avgs = {}
        self.num_ranked = {}
        self.num_played = {}
        self.ranks = {}
        self.id = DipPlayer.id
        DipPlayer.id = DipPlayer.id + 1
        #Q&A
        if first_name == 'Geoff':
          geoffs.append(self)

    def add_game(self, game):
      if not (self.games.has_key(game.fileyear)):
        self.games[game.fileyear] = []
      self.games[game.fileyear].append(game)

    def print_summary(self, year, f):
        f.write(html_header(self.name + ' (' + year + ')'))
        self.print_detail_summary_vertical(year, f)
        f.write('<p>' + table_link(year))
        f.write('<br>' + html_link('Historical entry', 
            '../hist/player' + str(self.id) + '.html'))
        f.write(html_footer())
    
    def print_hist_summary(self, f):
        f.write(html_header(self.name))
        self.print_yearly_summary(f)
        self.print_detail_summary_vertical('hist', f)
        f.write('<p>' + html_link('Front', 'front.html'))
        f.write(html_footer())
    
    def print_yearly_summary(self, f):
        p_years = self.games.keys()
        if len(p_years) == 0:
            return
        p_years.sort()
        f.write('<P ALIGN="CENTER">\n')
        f.write('<TABLE BORDER=1>\n')
        f.write('<TR><TH COLSPAN=' + str(2 + len(p_years)) + '>' + self.name)
        f.write('</TH></TR>\n')
        f.write('<TR><TH></TH>')
        for y in p_years:
            f.write('<TH>' + html_link(short_season(y), '../' + y +
                '/player' + str(self.id) + '.html') + '</TH>')
        f.write('<TH>All</TH></TR>\n')
        if len(p_years) >= 20:
          roundfunc = zerodps
        else:
          roundfunc = onedps
        f.write('<TR ALIGN=CENTER><TH ALIGN=LEFT>Games</TH>')
        for y in p_years:
          f.write(html_table_cell(len(self.games[y])))
        f.write(html_table_cell(len(concat(self.games))))
        f.write('</TR>\n')
        f.write('<TR ALIGN=CENTER><TH ALIGN=LEFT>Rank</TH>')
        for y in p_years:
          if self.ranks.has_key(y):
            f.write(html_table_cell(self.ranks[y]))
          else:
            f.write(html_table_cell(''))
        f.write(html_table_cell(''))
        f.write('</TR>\n')
        f.write('<TR ALIGN=CENTER><TH ALIGN=LEFT>Avg. score</TH>')
        for y in p_years:
          f.write(html_table_cell(roundfunc(self.avgs[y])))
        f.write(html_table_cell('<EM>' + twodps(self.avgs['hist']) + '</EM>'))
        f.write('</TR>\n')
        f.write(html_table_close())

    def print_detail_summary_vertical(self, year, f):
        f.write('<P ALIGN="CENTER">\n')
        f.write('<TABLE BORDER=1 WIDTH="40%">\n')
        f.write('<TR ALIGN=CENTER><TH COLSPAN=6>' + self.name + '</TH></TR>\n')
        if(year == 'hist'):
          games = concat(self.games)
        else:
          games = self.games[year]
        for g in games:
            f.write('  <TR ALIGN=CENTER>' +
             '<TD ALIGN=LEFT>' + g.link_game_from(year) + g.r_ast() + '</TD>' +
             '<TD ALIGN=LEFT>' + g.variant.html_ref() +'</TD>\n' +
             '    <TD> ' + g.pow_by_player[self].name + ' </TD>' +
             '<TD> ' + str(g.pow_by_player[self].last_year) + ' </TD>' +
             '<TD> ' + str(g.pow_by_player[self].end_sc) + ' </TD>' +
             '<TD> ' + twodps(g.pow_by_player[self].score) + ' </TD>' +
             '</TR>\n')
        f.write('<TR><TH COLSPAN=5>Average:</TH><TD ALIGN=CENTER><EM>' +
                twodps(self.avgs[year]) + '</EM></TD></TR>\n')
        f.write(html_table_close())
    
    # count number of ranked games in a certain year and
    # compute the average score in ranked games OR from all games
    def compute_avg(self, year):
        total = 0
        counted_games = 0
        if(year == 'hist'):
          games = concat(self.games)
        else:
          games = self.games[year]
        self.num_played[year] = len(games)
        for g in games:
          if g.ranking():
            counted_games = counted_games + 1
            total = total + g.pow_by_player[self].score
        # If player has played only non-ranking games use those instead
        self.num_ranked[year] = counted_games
        if counted_games == 0:
          counted_games = len(games)
          for g in games:
            total = total + g.pow_by_player[self].score
        self.avgs[year] = total / counted_games

    def html_ref_local(self):
        return html_link(self.name, 'player' + str(self.id) + '.html')

# creates a new DipPlayer if there is not already one with that name
def find_player(name):
    if(name[0] == '*'):
      return DipPlayerFake(name[1:])
    if DipPlayer.master_list.has_key(name):
        p = DipPlayer.master_list[name]
    else:
        p = DipPlayer(name)
    return p

# creates the league table for a year, as well as all the player and
# variant pages for that year
def make_league_table(year):
    # Score each game.
    games = glist[year]
    for g in games:
        g.score()

    print '%%% Generating league table for', season(year), 'season %%%'

    plist = []
    for p in DipPlayer.master_list.values():
      if p.games.has_key(year):
        plist.append(p)

    # For each player, compute the average score and create a summary.
    maxr = 0
    maxp = 0
    for player in plist:
        player.compute_avg(year)
        pf = open('stats/' + year + '/player' + str(player.id) + '.html','w')
        player.print_summary(year, pf)
        pf.close()
        if(player.num_ranked[year] > maxr):
          maxr = player.num_ranked[year]
        if(player.num_played[year] > maxp):
          maxp = player.num_played[year]

    # Generate a summary for each non-drop variant.
    for v in DipVariantGroup.name_table.values():
      if not v.has_games(year):
        continue
      for i in v.instances:
        i.compute_avg(year)
      vf = open('stats/' + year + '/variant' + str(v.id) + '.html','w')
      v.print_summary(year, vf)
      vf.close()

    if not year:
        return
    f = open('stats/' + y + '/table.html','w')
    print_table(year, games, plist, maxr, maxp, False, f)
    f.close()
    f = open('stats/' + y + '/fulltable.html','w')
    print_table(year, games, plist, maxr, maxp, True, f)
    f.close()

def print_table(year, games, plist, maxr, maxp, full, f):
    f.write(html_header('League Table'))
    f.write('<P ALIGN=CENTER>\n')
    f.write('<TABLE BORDER=1>\n')

    # Print the headers of the table.
    f.write ('<TR><TH COLSPAN="' + str(4 + len(games)) + '">League Table for ')
    f.write (season(y) + '</TH>\n')
    f.write ('<TR><TH>Pos.</TH><TH ALIGN="LEFT"> Name </TH><TH> Pld. </TH><TH> Avg. </TH>\n')
    for g in games:
        f.write ('<TH>' + g.link_game_from(year) + g.r_ast() + '</TH>\n')    
    f.write('</TR>\n')

    # If we have >= 10 games then we need to make output a bit smaller
    # so we can make it fit without too much trouble in one screenful

    if len(games) >= 13:
        roundfunc = zerodps
        emptycell = '  '
    elif len(games) >= 10:
        roundfunc = onedps
        emptycell = '    '
    else:
        roundfunc = twodps
        emptycell = '     '
    
    # display avergaes only for players with at least 2 ranked games
    # and completely ignore players with less than 2 games of any sort,
    # unless at start of season or full option is true
    splitlist = [[],[]]
    if(maxr == 0):
      splitlist[0] = plist
    else:
      for player in plist:
        if ((player.num_ranked[year] >= 2) or
          ((player.num_ranked[year] == 1) and (maxr <= 2) and
          ((year == current_year) or player.num_played[year] >= 2))):
          splitlist[0].append(player)
        elif (full or ((player.num_played[year] >= 2) or
          ((year == current_year) and (maxp <= 3)))):
          splitlist[1].append(player)
    # Sort the list of players by score.    
    splitlist[0].sort(cmpbyavgs(year))
    splitlist[1].sort(cmpbyavgs(year))

    # For each player, in sorted order...
    table_pos = 1
    for i in [0,1]:
      for player in splitlist[i]:
        # Print name, number of games, and rounded score.
        f.write ('<TR ALIGN="CENTER"><TH>')        
        if ((player.num_ranked[year] >= 3) or ((year != current_year) and
          ((player.num_ranked[year] >= maxr-1) and (maxr >= 2) and
          (player.num_played[year] >= 3)))):
          # You must play at least 3 games to get a ranking.
          f.write(str(table_pos))
          player.ranks[year] = table_pos
          table_pos = table_pos + 1
        f.write ('</TH><TD ALIGN="LEFT">' + player.html_ref_local() +
          '</TD>\t')
        f.write ('<TD>' + str(len(player.games[year])) + '</TD>')
        if(i == 0):
          f.write ('<TD><EM>' + twodps(player.avgs[year]) + '</EM></TD>\t')
        else:
          f.write ('<TD><EM>-</EM></TD>\t')
        # For each game played, check if this player played in it and
        # if so print the rounded score in that game.  Otherwise, just
        # leave the cell empty.
        for g in games:
          f.write (html_table_cell_open())
          if g in player.games[year]:
            f.write (roundfunc(g.pow_by_player[player].score))
          else:
            f.write(emptycell)
          f.write (html_table_cell_close())
        f.write('</TR>\n')

    # Bottom of the table and footers.
    f.write (html_table_close()
             + 'Note: You must play at least 3 games to get a ranking.\n'
         + 'Games marked * are not included in the average score.\n'
         + '<p>' + html_link('Front', '../hist/front.html')
             + html_footer())


# creates the historical league table, as well as all the historical
# player and variant pages
def make_hist_league_table(f):
    print('%%% Creating historical summaries %%%')
    global glist
    games = concat(glist)
    # For each player, compute the average score and create a summary.
    plist = DipPlayer.master_list.values()
    for player in plist:
        player.compute_avg('hist')
        pf = open('stats/hist/player' + str(player.id) + '.html','w')
        player.print_hist_summary(pf)
        pf.close()

    # Generate a summary for each non-drop variant.
    for v in DipVariantGroup.name_table.values():
      for i in v.instances:
        i.compute_avg('hist')
      vf = open('stats/hist/variant' + str(v.id) + '.html','w')
      v.print_hist_summary(vf)
      vf.close()

    # Sort the list of players by score.    
    plist.sort(cmpbyavgs('hist'))
    
    f.write(html_header('League Table'))
    f.write('<P ALIGN=CENTER>\n')
    f.write('<TABLE BORDER=1>\n')

    # Print the headers of the table.
    f.write ('<TR><TH COLSPAN="' + str(4 + len(years)) + '">')
    f.write ('Historical League Table</TH>\n')
    f.write ('<TR><TH>Pos.</TH><TH ALIGN="LEFT"> Name </TH><TH> Pld. </TH><TH> Avg. </TH>\n')
    for y in years:
      f.write ('<TH>' + html_link(short_season(y), '../' + y + '/table.html') +
      '</TH>\n')   
    f.write('</TR>\n')

    # If we have >= 10 games then we need to make output a bit smaller
    # so we can make it fit without too much trouble in one screenful

    if len(years) >= 13:
        roundfunc = zerodps
        emptycell = '  '
    elif len(years) >= 10:
        roundfunc = lambda f: str(round(f, 1))
        emptycell = '    '
    else:
        roundfunc = twodps
        emptycell = '     '

    # For each player, in sorted order...
    table_pos = 1
    for player in plist:
      # Print name, number of games, and rounded score.
      if player.num_ranked['hist'] < 3:
        continue
      f.write ('<TR ALIGN="CENTER"><TH>')
      if player.num_ranked['hist'] >= 7:
            # You must play at least 7 games to get a ranking.
        f.write(str(table_pos))
        table_pos = table_pos + 1
      f.write ('</TH><TD ALIGN="LEFT">' + player.html_ref_local() + '</TD>\t')
      f.write ('<TD>' + str(len(concat(player.games))) + '</TD>')
      f.write ('<TD><EM>' + twodps(player.avgs['hist']) + '</EM></TD>\t')

        # For each game played, check if this player played in it and
        # if so print the rounded score in that game.  Otherwise, just
        # leave the cell empty.
      for y in years:
        f.write (html_table_cell_open())
        if player.games.has_key(y):
            f.write (roundfunc(player.avgs[y]))
        else:
            f.write(emptycell)
    f.write (html_table_cell_close())
    f.write('</TR>\n')

    # Bottom of the table and footers.
    f.write (html_table_close()
             + 'Note: You must play at least 7 games to get a ranking.\n'
         + 'Games marked * are not included in the average score.\n'
         + '<p>' + html_link('Front', 'front.html')
             + html_footer())


def textlist(l):
    n = len(l)
    text = '' 
    for i in range(n):
      text += l[i]
      if i < (n-2):
        text += ', '
      if i == (n-2):
        text += ', and '
    return text

def make_hist_front(f):
    print('%%% Creating front %%%')
    global glist
    games = concat(glist)
    f.write(html_header('Statistics'))
    f.write('<p><h3>League tables</h3>')
    f.write('<p>These league tables are generated from the written records ' +
        'that DipSoc has of games played from Michaelmas 1996 onwards. ' +
    'Please point out any errors (misspelled names, broken links, etc) to ' +
    '<a href="mailto:soc-dip-committee@lists.cam.ac.uk">the committee</a>.')
    
    f.write('<p> League tables by season: <ul>')    
    for y in years:
        f.write('<li>' + html_link(season(y), '../' + y + '/table.html'))
    
    f.write('</ul>An explanation of the algorithm used to score the games ' +
        'can be found on <a href="../../house_rules.html">this page</a>.<br>')
    f.write('There is an additional record of all ' +
        '<a href="alldayers.html">all-day games</a>.')
    af = open('stats/hist/alldayers.html', 'w')
    make_alldayers(af)
    af.close()
    f.write('<br>The <a href="../scoredata.tar.gz">data files</a> used to' +
      ' generate the tables 1996-2008 are also available.')
        
    f.write('<p><h3>Variants</h3><p>')
    groups = DipVariantGroup.name_table.values()[:]
    groups.sort(cmpbyname)
    for v in groups:
        times_played = 0
        for i in v.instances:
          times_played = times_played + len(concat(i.games))
        if(times_played > 0):
          f.write(v.html_ref())
        else:
          f.write(v.name)
        f.write(' (' + str(times_played) + ')<br>')

    stdnames = {'A': 'Austria', 'E': 'England', 'F': 'France',
        'G': 'Germany', 'I': 'Italy', 'R': 'Russia', 'T': 'Turkey'}
    max_score = 0
    for pn in stdvar.start_sc.keys():
        avg = stdvar.avgs['hist'][pn]
        if avg > max_score:
          max_score = avg
          max_power = pn
    max_games = 0
    entries_m = entries_f = entries_n = entries_u = 0
    for p in DipPlayer.master_list.values():
      p_played = len(concat(p.games)) 
      if p_played > max_games:
        max_games = p_played
        max_player = p
      if p.gender == 'm':
        entries_m = entries_m + p_played
      if p.gender == 'f':
        entries_f = entries_f + p_played
      if p.gender == 'n':
        entries_n = entries_n + p_played
      if p.gender == 'u':
        entries_u = entries_u + p_played
    m_part = 100.0 * entries_m / (entries_m + entries_f)
    if entries_u:
        print "Unknown first names written to data/names_u."
    
    f.write('<p><h3>Q&A</h3><p>')
    f.write('Q: How many games are included in the statistics?<br>')
    f.write('A: ' + str(len(games)) + '<br><br>\n')
    f.write('Q: What is the total number of years played in these games?<br>')
    f.write('A: ' + str(total_years) + '<br><br>\n')
    f.write('Q: What power in ' + stdvar.html_ref() +
        ' has the highest average score?<br>')
    f.write('A: ' + stdnames[max_power] + ' (' + twodps(max_score) +
      ')<br><br>\n')
    f.write('Q: How often has someone been elimated within 2 years in a ' +
      stdvar.html_ref() +' game?<br>')
    n = 0 
    elimtexts = []
    for p in two_year_elims.keys():
      elimtexts.append(stdnames[p] + ' in '
        + textlist(map(lambda g: g.link_game_global(), two_year_elims[p])))
      n += len(two_year_elims[p])
    f.write('A: ' + str(n) + ' times (')
    f.write(textlist(elimtexts))
    f.write(')<br><br>\n')
    f.write('Q: Who has played the largest number of games?<br>')
    f.write('A: ' + max_player.html_ref_local() + ' (' +
      str(max_games) + ')<br><br>\n')
    f.write('Q: How many Geoffs are there in the DipSoc records?<br>')
    f.write('A: ' + str(len(geoffs)) + ' (' +
        textlist(map(lambda p: p.html_ref_local(), geoffs)))
    f.write(')<br><br>')
    f.write('Q: Are men ridiculously overrepresented in the records?<br>')
    f.write('A: ')
    if m_part > 0.95:
        f.write('Yes. ')
    if m_part < 0.60:
        f.write('No. ')
    f.write(str(round(m_part, 1)) + '% of the player entries are men.<br><br>')
    f.write('Q: Who made these useless pages anyway?<br>')
    f.write('A: The scripts used to generate the league tables were' +
      ' originally written by ' +
      DipPlayer.master_list['Gaute Strokkenes'].html_ref_local() +
      ' and have been modified by ' +
      DipPlayer.master_list['Johannes Nordstrm'].html_ref_local() +
      '.<br><br>')
    f.write(html_footer())
    
    
def read_names():
    g = open('data/names_m', 'r')
    for l in g.readlines():
      names[l[:-1]] = 'm'
    g.close()
    g = open('data/names_f', 'r')
    for l in g.readlines():
      names[l[:-1]] = 'f'
    g.close()
    g = open('data/names_n', 'r')
    for l in g.readlines():
      names[l[:-1]] = 'n'
    g.close()

def make_alldayers(f):
    for v in [stdvar]:
      games = v.alldayers
      powers = v.start_sc.keys()
      f.write(html_header('All-day games'))
      f.write('<P ALIGN=CENTER>\n')
      f.write('<TABLE BORDER=1 WIDTH="40%">\n')

      # Print the headers of the table.
      f.write ('<TR><TH COLSPAN="' + str(2 + len(powers)) + '">')
      f.write (v.html_ref() + '</TH>\n')
      f.write ('<TR><TH>Game</TH>')
      for p in powers:
        f.write ('<TH>' + p + '</TH>\n')
      f.write('<TH>Last</TH></TR>\n')
      for g in games:
        f.write('<TR ALIGN=CENTER><TH ALIGN=LEFT>' +
          g.link_game_from('hist') + '</TH>')
        for p in powers:
          pow = g.pow_by_letter[p]
          if (pow.end_sc == 0):
            f.write(html_table_cell('<EM>' + str(pow.last_year) + '</EM>'))
          else:
            f.write(html_table_cell(str(pow.end_sc)))
        f.write(html_table_cell(str(g.last_year) + '</TR>'))
      f.write (html_table_close())
    f.write('<p>' + html_link('Front', 'front.html') + html_footer())



# Initialise
names = {}
read_names()
glist = {}
today_date = str(datetime.date.today())

#Q&A
geoffs = []
total_years = 0
two_year_elims = {}
most_played = 0
stdvar = find_variant('Standard')

# Do the work.
for y in years:
    glist[y] = map(DipGame, files[y], [y]*len(files[y]))
    for g in glist[y]:
        f = open('stats/' + y + '/' + g.name + '.html', 'w')
        g.score()
        g.print_summary(f)
        f.close()

    make_league_table(y)

f = open('stats/hist/table.html', 'w')
make_hist_league_table(f)
f.close()

f = open('stats/hist/front.html', 'w')
make_hist_front(f)
f.close()



f = open('data/names_u', 'w')

for n in names.keys():
    if names[n] == 'u':
      f.write(n + '\n')
f.close()
